unit Unit1;

{ http://alpov.ic.cz/ }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp;

const
  MaxVytahu = 50;

type
  TForm1 = class(TForm)
    ClientSocket1: TClientSocket;
    btConnect: TButton;
    Memo1: TMemo;
    ServerEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    PortEdit: TEdit;
    edCmd: TEdit;
    btSend: TButton;
    edPos: TEdit;
    btHelp: TButton;
    procedure btConnectClick(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btSendClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btHelpClick(Sender: TObject);
  private
    PocetVytahu: Integer;
    PoziceVytahu: array[0..MaxVytahu] of Integer;
    Pouzivany: array[0..MaxVytahu] of Boolean;
    Otevrit: Boolean;
    Zavrit: Boolean;
    procedure SendCommand(Cmd: string);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btConnectClick(Sender: TObject);
begin
  if not ClientSocket1.Socket.Connected then begin
    ClientSocket1.Address := ServerEdit.Text;
    ClientSocket1.Port := StrToInt(PortEdit.Text);
    ClientSocket1.Open; // pripojeni na server
    while not ClientSocket1.Socket.Connected do Application.ProcessMessages;
    SendCommand('param');  // ziskani zakladnich informaci
    btConnect.Caption := 'Odpojit';
  end else begin
    ClientSocket1.Close; // odpojeni od serveru
    btConnect.Caption := 'Pipojit';
  end;
end;

procedure TForm1.SendCommand(Cmd: string);
begin
  Memo1.Lines.Add('Poslano: ' + Cmd); 
  ClientSocket1.Socket.SendText(Cmd + #$0D#$0A);  // odeslani prikazu
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);  // hlavni cast kodu
var
  S: string;
  CmdList: TStringList;
  Cmd: array[1..10] of string;
  I, J: Integer;
  NejblPatro, NejblVytah, CilPatro: Integer;
begin
  CmdList := TStringList.Create;
  CmdList.Text := Socket.ReceiveText; // jednotlive udalosti serveru budou kazda na zvl. radku

  for J := 0 to CmdList.Count - 1 do begin
    S := CmdList[J]; // zpracovani jednotlivych udalosti

    Memo1.Lines.Add('Prijato: ' + S);

    S := S + ' ';
    I := 0;
    while Length(S) > 0 do begin
      Inc(I);
      Cmd[I] := Copy(S, 1, Pos(' ', S) - 1);
      Delete(S, 1, Pos(' ', S));
    end; // rozdeleni do pole Cmd

    if Cmd[1] = 'cabinbutton' then begin // obsluha tlacitka v kabine

      if StrToInt(Cmd[3]) = PoziceVytahu[StrToInt(Cmd[2])] then begin
        Pouzivany[StrToInt(Cmd[2])] := True; // pokud uz je v danem patre, pouze otevrit dvere
        SendCommand('open ' + Cmd[2]);
        Otevrit := True; Zavrit := False;
      end else begin
        Pouzivany[StrToInt(Cmd[2])] := True; // jinak nahodit kontrolku, zavrit dvere a poslat ho tam kam chce
        SendCommand('indion ' + Cmd[2] + ' ' + Cmd[3]);
        SendCommand('shaftinfo ' + Cmd[2] + ' ' + Cmd[3]);
        SendCommand('close ' + Cmd[2]);
        Otevrit := False; Zavrit := True;
        Sleep(5000);
        SendCommand('floor ' + Cmd[2] + ' ' + Cmd[3]);
      end;

    end else if Cmd[1] = 'levelbuttonup' then begin // obsluha tlacitka "nahoru"
      SendCommand('indiupon ' + Cmd[2]); // nahodit kontrolky
      SendCommand('lipinfo ' + Cmd[2]);
      CilPatro := StrToInt(Cmd[2]);
      NejblVytah := -1; NejblPatro := MaxInt; // vyhlednani vytahu, ktery je k danemu
      for I := 0 to PocetVytahu - 1 do begin  // patru prave ted nejbliz a neni pouzivany
        if (Abs(PoziceVytahu[I] - CilPatro) < NejblPatro) and (not Pouzivany[I]) then begin
          NejblVytah := I;
          NejblPatro := Abs(PoziceVytahu[I] - CilPatro);
        end;
      end;
      if NejblVytah <> -1 then begin // pokud opravdu neni pouzivany
        if NejblPatro <> 0 then begin // pokud v nem neni, tak tam zajed
          SendCommand('floor ' + IntToStr(NejblVytah) + ' ' + Cmd[2]);
          Otevrit := False; Zavrit := False;
        end else begin // jinak staci otevrit dvere
          SendCommand('open ' + IntToStr(NejblVytah));
          Otevrit := True; Zavrit := False;
        end;
      end;

    end else if Cmd[1] = 'levelbuttondn' then begin // tlacitko "dolu", podobne jako "nahoru"
      SendCommand('indidnon ' + Cmd[2]);
      SendCommand('lipinfo ' + Cmd[2]);
      CilPatro := StrToInt(Cmd[2]);
      NejblVytah := -1; NejblPatro := MaxInt;
      for I := 0 to PocetVytahu - 1 do begin
        if (Abs(PoziceVytahu[I] - CilPatro) < NejblPatro) and (not Pouzivany[I]) then begin
          NejblVytah := I;
          NejblPatro := Abs(PoziceVytahu[I] - CilPatro);
        end;
      end;
      if NejblVytah <> -1 then begin // pokud opravdu neni pouzivany
        if NejblPatro <> 0 then begin
          SendCommand('floor ' + IntToStr(NejblVytah) + ' ' + Cmd[2]);
          Otevrit := False; Zavrit := False;
        end else begin
          SendCommand('open ' + IntToStr(NejblVytah));
          Otevrit := True; Zavrit := False;
        end;
      end;

    end else if Cmd[1] = 'shafts' then begin // nastaveni poctu vytahu
      PocetVytahu := StrToInt(Cmd[2]);

    end else if Cmd[1] = 'blocked' then begin // pokud se dvere oteviraly nebo zaviraly a pritom
      if Zavrit then SendCommand('close ' + Cmd[2]) // byly blokovane, tak to zkusime za chvili znovu
      else if Otevrit then SendCommand('open ' + Cmd[2]);
      Sleep(500);

    end else if Cmd[1] = 'level' then begin // ve spravnem patre otevrit dvere
      PoziceVytahu[StrToInt(Cmd[2])] := StrToInt(Cmd[3]);
      SendCommand('open ' + Cmd[2]);
      Otevrit := True; Zavrit := False;

    end else if Cmd[1] = 'opened' then begin // po otevreni dveri shodit indikatory
      Pouzivany[StrToInt(Cmd[2])] := False;
      SendCommand('indioff ' + Cmd[2] + ' ' + IntToStr(PoziceVytahu[StrToInt(Cmd[2])]));
      SendCommand('indiupoff ' + IntToStr(PoziceVytahu[StrToInt(Cmd[2])]));
      SendCommand('indidnoff ' + IntToStr(PoziceVytahu[StrToInt(Cmd[2])]));
      SendCommand('lipinfo ---');
      SendCommand('shaftinfo ' + Cmd[2] + ' ---');
      Otevrit := False; Zavrit := False;

    end;

  end;
  CmdList.Free;

  // vypsani pozice vytahu tak jak si je mysli klient
  edPos.Text := IntToStr(PoziceVytahu[0]);
  for I := 1 to PocetVytahu - 1 do edPos.Text := edPos.Text + ' - ' + IntToStr(PoziceVytahu[I]);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ClientSocket1.Close;                  // pri ukonceni programu
end;

procedure TForm1.btSendClick(Sender: TObject);
begin
  SendCommand(edCmd.Text);              // poslat prikaz z editu
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to MaxVytahu do begin      // init promennych
    PoziceVytahu[I] := 0;
    Pouzivany[I] := False;
  end;
end;

procedure TForm1.btHelpClick(Sender: TObject);
begin
  Application.MessageBox('Pipojit/Odpojit - d spojen se serverem'#$D#$A +
                         'Server/Port - adresa a port serveru'#$D#$A +
                         'Log komunikace - zobrazuje informace o komunikaci se serverem'#$D#$A +
                         'Pkaz/Poslat - umouje run vkldn pkaz'#$D#$A +
                         'Pozice vytahu - ukazje pozice vtah v achtch', 'Npovda');
end;

end.
